*************************************************************************
*                      interface routines                               *
*          for CompHEP 4.10  -  PYTHIA 6.2 interface                    *
*************************************************************************
*  15.12.99         Ilyin V.A.                                          *  
*  24.12.99         Modified by A. Belyaev    for   PYTHIA 6.1          *
*  18.05.2000  Modified by A.Skachkova for CompHEP version N4           *
*  22.10.2000    SETWID is removed, V.A.Ilyin                           *
*  22.10.2000  Zero masses protected, V.A.Ilyin                         *
*  25.11.2001  updated to PYTHIA 6.2 by V.A.Ilyin                       *
*  10.05.2002  bug on CTEQ5m, improved by A.Sherstnev                   *
*************************************************************************

*****************************************
*...write event (in PYJETS format)
*****************************************
      SUBROUTINE EVOUT
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)      
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      SAVE
      
      WRITE(6,*) N,((K(I,J),J=1,5),I=1,N),((P(I,J),J=1,5),I=1,N),
     .             ((V(I,J),J=1,5),I=1,N)
     
      RETURN
      END

**************************************************
*...read number of subprocesses
*************************************************
      SUBROUTINE SUBNUM
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
*...CompHEP-PYTHIA interface   
      CHARACTER LINE*80,PROCESS*80,EVFILE*500
      INTEGER IS,NEVPY,FIREVT      
      COMMON/INPARM/IS,NEVPY,FIREVT,PROCESS,EVFILE
      COMMON/SUBPROC/NNUP(100),KFP(100,20),
     .               NEV(100),XM(100,20,3),SIGMA(100),NPROC
  
      IS = 44
1     READ(IS,FMT='(A80)') LINE
      IF (LINE(1:26).EQ.'#Number_of_subprocesses = ') THEN
         READ(LINE,FMT='(26x,i4)') nproc 
      ELSE
         GOTO 1
      ENDIF  
      REWIND IS                  

      RETURN
      END           

*****************************
*...read header of the event file
************************************
      SUBROUTINE RHEADER
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
*...PYTHIA common blocks
      INTEGER PYCOMP
      COMMON /PYPARS/ MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
*...CompHEP-PYTHIA interface
      CHARACTER*80 PROCESS
      CHARACTER*500 EVFILE
      CHARACTER*1000 LINE
      CHARACTER*16 BEAM*16
      CHARACTER*100 EMPTYS
      CHARACTER*100 SPROCESS
      CHARACTER*100 STRF1,STRF2
      INTEGER IS,NEVPY,FIREVT      
      COMMON/INPARM/IS,NEVPY,FIREVT,PROCESS,EVFILE

      COMMON/SUBPROC/NNUP(100),KFP(100,20),
     .               NEV(100),XM(100,20,3),SIGMA(100),NPROC
      COMMON/BEAMS/SQRTS,RPDTY,KFB(2),BMASS(2),BEAM(2)
      SAVE
      
*...Which PevLIB version do you use?
      READ(IS,1001) LINE

*...Loop over of subprocesses
      DO 100 NPRC=1,NPROC

*...Which CompHEP version do you use?
        READ(IS,1001) LINE

*...Read particles names for the subprocess and get their KF codes 
        SPROCESS = EMPTYS(100)
        READ(IS,1009) LINE
        READ(LINE,FMT='(A100)') SPROCESS
      
        CALL R_PROC(NPRC,SPROCESS)

*...Omit string "initial state"
        READ(IS,1001) LINE

*...Read CMS energy and rapidity for Lorentz boost 
*...to transform CMS to the collision frame used in CompHEP
        SQRTS0 = SQRTS
        RPDTY0 = RPDTY
        READ(IS,1009) LINE
        READ(LINE,FMT='(G14.6)', ERR=2001) SQRTS
      
*...Avoid conflict with "remnant" approach to ISR for electron beam:
       SQRTS = SQRTS*1.0000001

        READ(IS,1017) LINE
        READ(LINE,FMT='(G14.6)', ERR=2002) RPDTY
        IF (NPRC.GT.1) THEN
          delt = abs(SQRTS-SQRTS0)
          IF (delt.lt.1.d-10) SQRTS=SQRTS0
          delt = abs(RPDTY-RPDTY0)
          IF (delt.lt.1.d-10) RPDTY=RPDTY0
          IF ((SQRTS.NE.SQRTS0).or.(RPDTY.NE.RPDTY0)) THEN
            WRITE(*,*) 'Invalid SQRTS or RPDTY in subprocesses'
            STOP
          ENDIF
        ENDIF

*...read names of beams used in CompHEP and get their KF codes and masses
        KFB1=KFB(1)
        KFB2=KFB(2)
        READ(IS,1010) LINE
        READ(LINE,FMT='(A80)') STRF1
        BEAM(1) = EMPTYS(20)	
        CALL R_BEAM(STRF1,KFB(1),BEAM(1),BMASS(1),PDFGUP(1),PDFSUP(1))
        IF(BEAM(1).EQ.'no') KFB(1)=KFP(nprc,1)
        IF((BEAM(1).EQ.'electron').and.(KFP(nprc,1).lt.0))KFB(1)=-KFB(1)

        READ(IS,1010) LINE
        READ(LINE,FMT='(A80)') STRF2
        BEAM(2) = EMPTYS(20)
        CALL R_BEAM(STRF2,KFB(2),BEAM(2),BMASS(2),PDFGUP(2),PDFSUP(2))
        IF(BEAM(2).EQ.'no') KFB(2)=KFP(nprc,2)
        IF((BEAM(2).EQ.'electron').and.(KFP(nprc,2).lt.0))KFB(2)=-KFB(2)
        CALL PYNAME(KFB(1),BEAM(1))
        CALL PYNAME(KFB(2),BEAM(2))
        IF ((NPRC.GT.1).and.((KFB1.NE.KFB(1)).or.(KFB2.NE.KFB(2)))) THEN
          WRITE(*,*) 'Invalid beams in subprocesses'
          STOP
        ENDIF

*...define beam momenta for PYTHIA 'USER" frame
        CALL BEAMFR
 
*...read particles masses in the subprocess
        READ(IS,1008) LINE
        READ(LINE,FMT='(20(G17.10))',ERR=2003) (XM(NPRC,i,1),
     +  i=1,NNUP(NPRC))

*...set out-particle masses in PYTHIA according to CompHEP events
        DO 30 i=3,NNUP(nprc)
          IF (XM(nprc,i,1).gt.0.d0) THEN
	    PMAS(PYCOMP(KFP(nprc,i)),1)=XM(nprc,i,1)
	  ENDIF
30      CONTINUE

*...read cross section of the subprocess in pb
        READ(IS,1021) LINE
        READ(LINE,FMT='(G13.6)', ERR=2004) SIGMA(NPRC)

*...read number of (unweighted) events in the input
        READ(IS,1023) LINE
        READ(LINE,FMT='(i10)', ERR=2005)  NEV(NPRC)

*...omit string: #----------------------------------------------------------
        READ(IS,1001) LINE

*...end of loop over subprocess headers
100   CONTINUE

*...omit string: #Number_of_subprocesses = xxx
      READ(IS,1001) LINE

*...read total cross section (not used)
      READ(IS,1027) LINE
      READ(LINE,FMT='(G18.3)', ERR=2006) XSIGMAT

*...read number of mixed events (not used)
      READ(IS,1030) LINE
      READ(LINE,FMT='(i10)', ERR=2007) NEVTOT

*...omit string: #Nproc ================== Events ==========================
      READ(IS,1001) LINE
      RETURN

 2001 WRITE(*,*) 'Invalid string for the sqrtS in subprocess = ',NPRC
      STOP
 2002 WRITE(*,*) 'Invalid string for the rapidity in subprocess = ',NPRC
      STOP
 2003 WRITE(*,*) 
     + 'Invalid string for the particle masses in subprocess = ',NPRC
      STOP
 2004 WRITE(*,*) 
     + 'Invalid string for the cross section in subprocess = ',NPRC
      STOP
 2005 WRITE(*,*) 
     + 'Invalid string for the events number in subprocess = ',NPRC
      STOP
 2006 WRITE(*,*) 'Invalid string for the full cross section'
      STOP
 2007 WRITE(*,*) 'Invalid string for the full events number'
      STOP

 1001 FORMAT( 1x,A1000)
 1008 FORMAT( 8x,A1000)
 1009 FORMAT( 9x,A1000)
 1010 FORMAT(10x,A1000)
 1017 FORMAT(17x,A1000)
 1021 FORMAT(21x,A1000)
 1023 FORMAT(23x,A1000)
 1027 FORMAT(27x,A1000)
 1030 FORMAT(30x,A1000)
      END


*******************************
* evaluate momenta of beams  
*******************************
      SUBROUTINE BEAMFR
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
*...PYTHIA common blocks
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
*...CompHEP-PYTHIA interface
      CHARACTER BEAM*16
      DIMENSION PBCMS(2,5)
      COMMON/SUBPROC/NNUP(100),KFP(100,20),
     .              NEV(100),XM(100,20,3),SIGMA(100),NPROC
      COMMON/BEAMS/SQRTS,RPDTY,KFB(2),BMASS(2),BEAM(2)
      SAVE

*...evaluate beams momenta in CMS
        PBCMS(1,1) = 0
        PBCMS(1,2) = 0
        PBCMS(1,3) = sqrt(SQRTS**2/4-BMASS(1)**2)
        PBCMS(1,4) = SQRTS/2
        PBCMS(1,5) = BMASS(1)
        PBCMS(2,1) = 0
        PBCMS(2,2) = 0
        PBCMS(2,3) = -sqrt(SQRTS**2/4-BMASS(2)**2)
        PBCMS(2,4) = SQRTS/2
        PBCMS(2,5) = BMASS(2)
*...evaluate beams momenta in the collison frame using Lorentz boost 
*...given from the CompHEP session
        P(1,1) = PBCMS(1,1)
        P(1,2) = PBCMS(1,2)
        P(1,3) = SINH(RPDTY)*PBCMS(1,4) + COSH(RPDTY)*PBCMS(1,3)
        P(1,4) = COSH(RPDTY)*PBCMS(1,4) + SINH(RPDTY)*PBCMS(1,3)
        P(1,5) = PBCMS(1,5)
        P(2,1) = PBCMS(2,1)
        P(2,2) = PBCMS(2,2)
        P(2,3) = SINH(RPDTY)*PBCMS(2,4) + COSH(RPDTY)*PBCMS(2,3)
        P(2,4) = COSH(RPDTY)*PBCMS(2,4) + SINH(RPDTY)*PBCMS(2,3)
        P(2,5) = PBCMS(2,5)
      
      RETURN
      END

******************************
* parsing the beam strings
******************************
      SUBROUTINE R_BEAM(STRF,KFB,BEAM,BMASS,IPDFGUP,IPDFSUP)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      CHARACTER BEAM*16,STRF*80
      COMMON /QCDPAR/ QCDLF(6),NL
      SAVE
      
*** error case
      IF (STRF.eq.'') THEN
         write(*,*) 'Error in STRF'
         stop
      ENDIF

*** default beam mass
      BMASS = 0

      DO 10 i=1,80
        IF (STRF(i:i).ne.' ') goto 20
10    continue

*** OFF case
20    IF(STRF(i:(i+2)).EQ.'OFF') THEN
         KFB = 0
         BEAM = 'no'
         RETURN
	 
*** Proton/AntiProton beam cases
      ELSEIF (STRF(i:(i+3)).EQ.'PDF:') THEN
         BMASS = 0.938    ! mass of proton
         NL=2             ! default NLL
         GOTO 50
	 
*** Electron beam cases
      ELSEIF(STRF(i:(i+2)).EQ.'ISR')THEN
         BEAM = 'electron'
         BMASS = 0.000511   ! mass of electron
         GOTO 99
	 
      ELSEIF(STRF(i:(i+11)).EQ.'Equiv.Photon')THEN
         BEAM = 'electron'
         BMASS = 0.000511   ! mass of electron
         GOTO 99
	 
*** Photon beam case
      ELSEIF(STRF(i:(i+13)).EQ.'Laser photons')THEN
         BEAM = 'gamma'
         GOTO 99
      ENDIF

*** error STRF
      GOTO 999

*** Proton or AntiProton beams 
50    k=i+4
      IF(STRF(k:(k+3)).eq.'MRST') THEN
        IPDFGUP=3
        IF (STRF((k+4):(k+6)).EQ.'c-g')  THEN      ! MRSTc-g(proton)
                    NL = 1           ! LO
                    IPDFSUP=72
                    QCDLF(5)=0.2374
                    K1 = k+8
        ENDIF
        IF (STRF((k+4):(k+5)).EQ.'ht')  THEN       ! MSRTht(proton)
                    NL = 2
                    IPDFSUP=77
                    QCDLF(5)=0.2086
                    K1 = k+7
        ENDIF
        GOTO 55
      ENDIF
           IF((STRF(k:k+3).eq.'cteq').or.(STRF(k:k+3).eq.'CTEQ')) THEN
             IPDFGUP=4
             IF(STRF((k+4):(k+5)).eq.'6l'.or.
     &          STRF((k+4):(k+5)).eq.'6L') THEN         ! CTEQ6L(proton)
                    NL=1                       !LO running alphas
                    IPDFSUP=-1
                    QCDLF(5)=0.146
                    K1 = k+7
             ENDIF
             IF(STRF((k+4):(k+6)).eq.'6l1'.or.
     &          STRF((k+4):(k+6)).eq.'6L1') THEN         ! CTEQ6L1(proton)
                    NL=1                       !LO running alphas
                    IPDFSUP=-1
                    QCDLF(5)=0.146
                    K1 = k+8
             ENDIF
             IF(STRF((k+4):(k+5)).eq.'6m'.or.
     &          STRF((k+4):(k+5)).eq.'6M') THEN        ! CTEQ6m(proton)
                    NL=2                       !NLL running alphas
                    IPDFSUP=-1
                    QCDLF(5)=0.226
                    K1 = k+7
             ENDIF
             IF(STRF((k+4):(k+5)).eq.'6d'.or.
     &          STRF((k+4):(k+5)).eq.'6D') THEN        ! CTEQ6m(proton)
                    NL=2                       !NLL running alphas
                    IPDFSUP=-1
                    QCDLF(5)=0.226
                    K1 = k+7
             ENDIF
             IF(STRF((k+4):(k+5)).eq.'5l'.or.
     &          STRF((k+4):(k+5)).eq.'5L') THEN         ! CTEQ5L(proton)
                    NL=1                       !LO running alphas
                    IPDFSUP=46
                    QCDLF(5)=0.146
                    K1 = k+7
             ENDIF
             IF(STRF((k+4):(k+5)).eq.'5m'.or.
     &          STRF((k+4):(k+5)).eq.'5M') THEN        ! CTEQ5m(proton)
                    NL=2                       !NLL running alphas
                    IPDFSUP=48
                    QCDLF(5)=0.226
                    K1 = k+7
             ENDIF
             IF(STRF((k+4):(k+6)).eq.'5m1'.or.
     &          STRF((k+4):(k+6)).eq.'5M1') THEN        ! CTEQ5m1(proton)
                    NL=2                       !NLL running alphas
                    IPDFSUP=53
                    QCDLF(5)=0.226
                    K1 = k+8
             ENDIF
             IF(STRF((k+4):(k+5)).eq.'4l'.or.
     &          STRF((k+4):(k+5)).eq.'4L') THEN         ! CTEQ4l(proton)
                    NL=1                       !LO running alphas
                    IPDFSUP=32
                    QCDLF(5)=0.181
                    K1 = k+7
             ENDIF
             IF(STRF((k+4):(k+5)).eq.'4m'.or.
     &          STRF((k+4):(k+5)).eq.'4M') THEN         ! CTEQ4m(proton)
                    NL=2                       !NLL running alphas
                    IPDFSUP=34
                    QCDLF(5)=0.202
                    K1 = k+7
             ENDIF
           GOTO 55
           ENDIF
           IF(STRF(k:(k+2)).eq.'GRV') THEN
             IPDFGUP=5
             IF (STRF((k+3):(k+10)).EQ.'98LO')  THEN  ! GRV98LO(proton)
                    NL = 1           ! LO
                    IPDFSUP=12
                    QCDLF(5)=0.1529
                    K1 = k+8
             ENDIF
             IF (STRF((k+3):(k+10)).EQ.'98HO')  THEN
                    NL = 2
                    IPDFSUP=13
                    QCDLF(5)=0.1334
                    K1 = k+8
             ENDIF
           GOTO 55
           ENDIF

           write(*,*) 'Unknown PDF set for proton/antiproton'
           stop
55    CONTINUE
      
      kk = 1
      DO 65 j=K1,80
        IF (STRF(j:j).eq.' '.or.STRF(j:j).eq.')') goto 99
        BEAM(kk:kk)=STRF(j:j)
        kk=kk+1
65    continue

*...get PYTHIA's KF code for the beam      
99    KFB = KFBEAM(BEAM)
      RETURN

999   WRITE(*,*) 'Unknown STRF'
      RETURN
      END

*********************************
* parsing the subprocess string
*********************************
      SUBROUTINE R_PROC(NPRC,PROCESS)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      COMMON/SUBPROC/NNUP(100),KFP(100,20),
     .              NEV(100),XM(100,20,3),SIGMA(100),NPROC
      CHARACTER*100 PROCESS
      CHARACTER*3 PNAME(1:20)
      INTEGER II
      SAVE

      NNUP(NPRC) = 0
      II = 0

5     CONTINUE
       II = II + 1

      IF (PROCESS(II:II).EQ.' ') GOTO 15
      IF (PROCESS(II:II).EQ.'-') THEN
        NIN = NNUP(NPRC)
        GOTO 5
c 	write(*,*) 'Warning: the interface version analyses initial ',
c     .'state in process strings only'
c	RETURN
      ENDIF
      IF (PROCESS(II:II).EQ.'>') GOTO 5
      NNUP(NPRC) = NNUP(NPRC)+1
      IF (NNUP(NPRC).GT.10) THEN
        write(*,*) 'Warning: more than 10 partons in final state'
      ENDIF

      PNAME(NNUP(NPRC)) = PROCESS(II:II+4)
      KFP(NPRC,NNUP(NPRC)) = KFPART(PNAME(NNUP(NPRC)))

      II = II + 3

      IF (KFP(NPRC,NNUP(NPRC)).eq.0) THEN
        write(*,*) 'II = ', II
        write(*,*) 'Unknown PYTHIA particle name: ',PNAME(NNUP(NPRC))
        STOP
      ENDIF

 15   IF (II.GE.80) goto 10
      GOTO 5
 10   continue

      IF (NNUP(NPRC).EQ.0) THEN
        WRITE(*,*) 'No process string in event file.'
        STOP
      ELSEIF(NIN.EQ.0) THEN
        WRITE(*,*) 'No IN particles in the process string.'
        STOP
      ELSEIF((NNUP(NPRC)-NIN).EQ.0) THEN
        WRITE(*,*) 'No OUT particles in the process string.'
        STOP
      ELSEIF(NIN.EQ.1) THEN
        WRITE(*,*) 'Decay process is not allowed.'
        STOP
      ENDIF

      RETURN
      END


*######################################################
*  Some service routines
*######################################################

********************
* make empty string
********************
      FUNCTION EMPTYS(N)
      CHARACTER*(*) EMPTYS
      SAVE

      DO 15 k=1,N
           EMPTYS(k:k)=' '
15    CONTINUE
      RETURN
      END

*******************************
* delete blanks in string
*******************************
      FUNCTION CMPRS(STR)
      CHARACTER*500 STR,XSTR,CMPRS
      CHARACTER*500 EMPTYS
      SAVE

      j=1
      XSTR = EMPTYS(500)
      DO 10 i=1,80
        IF(STR(i:i).ne.' ') THEN
          XSTR(j:j)=STR(i:i)
          j=j+1
        ENDIF
10    CONTINUE
      CMPRS = XSTR
      RETURN
      END

