*************************************************************************
*                         KFBEAM routine                                *
*          for CompHEP 41.10  -  PYTHIA 6.2 interface                   *
*************************************************************************
*  25.11.2001  Ilyin V.A.                                               *
*************************************************************************
      INTEGER FUNCTION kfbeam(bname)
      CHARACTER*16 bname

      kfbeam = 0
      IF (bname.eq.'Proton'.or.bname.eq.'proton'.or.
     . bname.eq.'p+') THEN 
            kfbeam=2212
      ELSEIF (bname.eq.'AntiProton'.or.bname.eq.'antiProton'.or.
     . bname.eq.'anti-proton'.or.bname.eq.'pbar-') THEN 
            kfbeam=-2212
      ELSEIF (bname.eq.'electron'.or.bname.eq.'e-') THEN 
            kfbeam=11
      ELSEIF (bname.eq.'positron'.or.bname.eq.'e+') THEN 
            kfbeam=-11
      ELSEIF (bname.eq.'gamma') THEN 
            kfbeam=22
      ELSE
            WRITE(*,*) 'Unknown for CompHEP/PYTHIA beam name: ',bname
      ENDIF

      RETURN
      END

*************************************************************************
*                         KFPART routine                                *
*          for CompHEP 41.10  -  PYTHIA 6.2 interface                   *
*************************************************************************
*  25.11.2001  Ilyin V.A.                                               *
*************************************************************************
      INTEGER FUNCTION kfpart(pname)
      CHARACTER*3 pname

      IF     (pname.eq.'e1 ') THEN 
            kfpart=11
      ELSEIF (pname.eq.'E1 ') THEN 
            kfpart=-11
      ELSEIF (pname.eq.'e  ') THEN 
            kfpart=11
      ELSEIF (pname.eq.'E  ') THEN 
            kfpart=-11
      ELSEIF (pname.eq.'e2 ') THEN 
            kfpart=13
      ELSEIF (pname.eq.'E2 ') THEN 
            kfpart=-13
      ELSEIF (pname.eq.'m  ') THEN 
            kfpart=13
      ELSEIF (pname.eq.'M  ') THEN 
            kfpart=-13
      ELSEIF (pname.eq.'e3 ') THEN 
            kfpart=15
      ELSEIF (pname.eq.'E3 ') THEN 
            kfpart=-15
      ELSEIF (pname.eq.'l  ') THEN 
            kfpart=15
      ELSEIF (pname.eq.'L  ') THEN 
            kfpart=-15
      ELSEIF (pname.eq.'e4 ') THEN 
            kfpart=17
      ELSEIF (pname.eq.'E4 ') THEN 
            kfpart=-17
      ELSEIF (pname.eq.'n1 ') THEN 
            kfpart=12
      ELSEIF (pname.eq.'N1 ') THEN 
            kfpart=-12
      ELSEIF (pname.eq.'ne ') THEN 
            kfpart=12
      ELSEIF (pname.eq.'Ne ') THEN 
            kfpart=-12
      ELSEIF (pname.eq.'n2 ') THEN 
            kfpart=14
      ELSEIF (pname.eq.'N2 ') THEN 
            kfpart=-14
      ELSEIF (pname.eq.'nm ') THEN 
            kfpart=14
      ELSEIF (pname.eq.'Nm ') THEN 
            kfpart=-14
      ELSEIF (pname.eq.'n3 ') THEN 
            kfpart=16
      ELSEIF (pname.eq.'N3 ') THEN 
            kfpart=-16
      ELSEIF (pname.eq.'nl ') THEN 
            kfpart=16
      ELSEIF (pname.eq.'Nl ') THEN 
            kfpart=-16
      ELSEIF (pname.eq.'n4 ') THEN 
            kfpart=18
      ELSEIF (pname.eq.'N4 ') THEN 
            kfpart=-18

      ELSEIF (pname.eq.'d# ') THEN
            kfpart=1
      ELSEIF (pname.eq.'D# ') THEN
            kfpart=-1
      ELSEIF (pname.eq.'u# ') THEN
            kfpart=2
      ELSEIF (pname.eq.'U# ') THEN
            kfpart=-2
      ELSEIF (pname.eq.'q# ') THEN
            kfpart=2
      ELSEIF (pname.eq.'Q# ') THEN
            kfpart=-2

      ELSEIF (pname.eq.'d  ') THEN 
            kfpart=1
      ELSEIF (pname.eq.'D  ') THEN 
            kfpart=-1
      ELSEIF (pname.eq.'u  ') THEN 
            kfpart=2
      ELSEIF (pname.eq.'U  ') THEN 
            kfpart=-2
      ELSEIF (pname.eq.'s  ') THEN 
            kfpart=3
      ELSEIF (pname.eq.'S  ') THEN 
            kfpart=-3
      ELSEIF (pname.eq.'c  ') THEN 
            kfpart=4
      ELSEIF (pname.eq.'C  ') THEN 
            kfpart=-4
      ELSEIF (pname.eq.'b  ') THEN 
            kfpart=5
      ELSEIF (pname.eq.'B  ') THEN 
            kfpart=-5
      ELSEIF (pname.eq.'t  ') THEN 
            kfpart=6
      ELSEIF (pname.eq.'T  ') THEN 
            kfpart=-6
      ELSEIF (pname.eq.'b4 ') THEN 
            kfpart=7
      ELSEIF (pname.eq.'B4 ') THEN 
            kfpart=-7
      ELSEIF (pname.eq.'t4 ') THEN 
            kfpart=8
      ELSEIF (pname.eq.'T4 ') THEN 
            kfpart=-8

      ELSEIF (pname.eq.'G  ') THEN 
            kfpart=21
      ELSEIF (pname.eq.'g  ') THEN 
            kfpart=21
      ELSEIF (pname.eq.'A  ') THEN 
            kfpart=22
      ELSEIF (pname.eq.'gamma') THEN 
            kfpart=22
      ELSEIF (pname.eq.'Z  ') THEN 
            kfpart=23
      ELSEIF (pname.eq.'Z0 ') THEN 
            kfpart=23
      ELSEIF (pname.eq.'W+ ') THEN 
            kfpart=24
      ELSEIF (pname.eq.'W- ') THEN 
            kfpart=-24
      ELSEIF (pname.eq.'H  ') THEN 
            kfpart=25
      ELSEIF (pname.eq.'h  ') THEN 
            kfpart=25

      ELSEIF (pname.eq.'h0 ') THEN 
            kfpart=25
      ELSEIF (pname.eq.'H0 ') THEN 
            kfpart=35
      ELSEIF (pname.eq.'A0 ') THEN 
            kfpart=36
      ELSEIF (pname.eq.'H3 ') THEN 
            kfpart=36
      ELSEIF (pname.eq.'H+ ') THEN 
            kfpart=37
      ELSEIF (pname.eq.'H- ') THEN 
            kfpart=-37

      ELSEIF (pname.eq.'Gr ') THEN                  ! Graviton
            kfpart=39
      ELSEIF (pname.eq.'R0 ') THEN 
            kfpart=41
      ELSEIF (pname.eq.'LQ ') THEN 
            kfpart=42

      ELSEIF (pname.eq.'~g ') THEN                  ! gluino
            kfpart= 1000021      

      ELSEIF (pname.eq.'~dL') THEN
            kfpart= 1000001
      ELSEIF (pname.eq.'~DL') THEN
            kfpart=-1000001
      ELSEIF (pname.eq.'~dR') THEN
            kfpart= 2000001
      ELSEIF (pname.eq.'~DR') THEN
            kfpart=-2000001
      ELSEIF (pname.eq.'~uL') THEN
            kfpart= 1000002 
      ELSEIF (pname.eq.'~UL') THEN
            kfpart=-1000002 
      ELSEIF (pname.eq.'~uR') THEN
            kfpart= 2000002
      ELSEIF (pname.eq.'~UR') THEN
            kfpart=-2000002
      ELSEIF (pname.eq.'~sL') THEN
            kfpart= 1000003  
      ELSEIF (pname.eq.'~SL') THEN
            kfpart=-1000003 
      ELSEIF (pname.eq.'~sR') THEN
            kfpart= 2000003 
      ELSEIF (pname.eq.'~SR') THEN
            kfpart=-2000003
      ELSEIF (pname.eq.'~cL') THEN
            kfpart= 1000004
      ELSEIF (pname.eq.'~CL') THEN
            kfpart=-1000004
      ELSEIF (pname.eq.'~cR') THEN
            kfpart= 2000004 
      ELSEIF (pname.eq.'~CR') THEN
            kfpart=-2000004
      ELSEIF (pname.eq.'~b1') THEN
            kfpart= 1000005 
      ELSEIF (pname.eq.'~B1') THEN
            kfpart=-1000005
      ELSEIF (pname.eq.'~b2') THEN
            kfpart= 2000005
      ELSEIF (pname.eq.'~B2') THEN
            kfpart=-2000005
      ELSEIF (pname.eq.'~t1') THEN
            kfpart= 1000006
      ELSEIF (pname.eq.'~T1') THEN
            kfpart=-1000006
      ELSEIF (pname.eq.'~t2') THEN
            kfpart= 2000006 
      ELSEIF (pname.eq.'~T2') THEN
            kfpart=-2000006 
      ELSEIF (pname.eq.'~eL') THEN
            kfpart= 1000011
      ELSEIF (pname.eq.'~EL') THEN
            kfpart=-1000011
      ELSEIF (pname.eq.'~eR') THEN
            kfpart= 2000011 
      ELSEIF (pname.eq.'~ER') THEN
            kfpart=-2000011
      ELSEIF (pname.eq.'~ne') THEN
            kfpart= 1000012
      ELSEIF (pname.eq.'~Ne') THEN
            kfpart=-1000012   
      ELSEIF (pname.eq.'~mL') THEN
            kfpart= 1000013 
      ELSEIF (pname.eq.'~ML') THEN
            kfpart=-1000013 
      ELSEIF (pname.eq.'~mR') THEN
            kfpart= 2000013
      ELSEIF (pname.eq.'~MR') THEN
            kfpart=-2000013
      ELSEIF (pname.eq.'~nm') THEN
            kfpart= 1000014 
      ELSEIF (pname.eq.'~Nm') THEN
            kfpart=-1000014
      ELSEIF (pname.eq.'~l1') THEN
            kfpart= 1000015
      ELSEIF (pname.eq.'~L1') THEN 
            kfpart=-1000015
      ELSEIF (pname.eq.'~l2') THEN
            kfpart= 2000015 
      ELSEIF (pname.eq.'~L2') THEN
            kfpart=-2000015
      ELSEIF (pname.eq.'~nl') THEN
            kfpart= 1000016  
      ELSEIF (pname.eq.'~Nl') THEN
            kfpart=-1000016
 
      ELSEIF (pname.eq.'~o1') THEN                  ! neutralino chi_10
            kfpart= 1000022
      ELSEIF (pname.eq.'~o2') THEN                  ! neutralino chi_20
            kfpart= 1000023 
      ELSEIF (pname.eq.'~o3') THEN                  ! neutralino chi_30
            kfpart= 1000025 
      ELSEIF (pname.eq.'~o4') THEN                  ! neutralino chi_40
            kfpart= 1000035 
      ELSEIF (pname.eq.'~1+') THEN                  ! chargino chi_1+
            kfpart= 1000024
      ELSEIF (pname.eq.'~1-') THEN                  ! chargino chi_1-
            kfpart=-1000024
      ELSEIF (pname.eq.'~2+') THEN                  ! chargino chi_2+
            kfpart= 1000037
      ELSEIF (pname.eq.'~2-') THEN                  ! chargino chi_2-
            kfpart=-1000037
c... other lebel for chargino (from extra-dimention theories)
      ELSEIF (pname.eq.'KG') THEN                  ! chargino chi_2-
            kfpart= 1000037

      ELSEIF (pname.eq.'~G') THEN                   ! gravitino
            kfpart=1000039
      ELSEIF (pname.eq.'~sS') THEN                  ! sgoldstino S
            kfpart=1000040
      ELSEIF (pname.eq.'~sP') THEN                  ! sgoldstino P
            kfpart=1000041


      ELSE 
            kfpart=0
      ENDIF

      RETURN
      END

