*************************************************************************
*                          Check routine                                *
*          for CompHEP 41.10  -  PYTHIA 6.2 interface                   *
*************************************************************************
*  07.09.2004       Sherstnev A.V.                                      *
*************************************************************************
      SUBROUTINE HEPRUP_PRINT
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)

      WRITE(*,*)'*********** HEPRUP COMMON BLOCK  ***********'
      WRITE(*,*)' Beam description:'
      WRITE(*,*)' Beam particle 1 = ',IDBMUP(1),
     +', Beam particle 2 = ',IDBMUP(2)
      WRITE(*,*)' Beam energy 1 = ',EBMUP(1),
     +', Beam energy 2 = ',EBMUP(2)
      WRITE(*,*)'  '

      WRITE(*,*)' Structure functions description:'
      WRITE(*,*)'  PDF Group ID 1 = ',PDFGUP(1),
     +',  PDF Group ID 2 = ',PDFGUP(2)
      WRITE(*,*)'  PDF Set ID 1 = ',PDFSUP(1),
     +', PDF Set ID 2 = ',PDFSUP(2)
      WRITE(*,*)'  '

      WRITE(*,*)'  Master switch = ', IDWTUP
      WRITE(*,*)'  Number of subprocesses = ', NPRUP
      DO I = 1, NPRUP
        WRITE(*,*)'Subprocess ',I,':'
        WRITE(*,*)'   Cross section = ', XSECUP(I),' +/- ', XERRUP(I)
        WRITE(*,*)'   Maximum weight = ', XMAXUP(I)
        WRITE(*,*)'   LPRUP = ', LPRUP(I)
      ENDDO
      WRITE(*,*)'******************** END ********************'
      END


      SUBROUTINE HEPEUP_PRINT
      INTEGER MAXPUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)
      SAVE /HEPEUP/

      WRITE(*,*)'*********** HEPEUP COMMON BLOCK  ***********'
      WRITE(*,*)'Event other parameters:'
      WRITE(*,*)'  Number of particle = ', NUP
      WRITE(*,*)'  Process ID = ',  IDPRUP
      WRITE(*,*)'  Event weght = ', XWGTUP
      WRITE(*,*)'QCD scale (GeV) = ', SCALUP
      WRITE(*,*)'QED coupling = ', AQEDUP
      WRITE(*,*)'QCD coupling = ', AQCDUP
      WRITE(*,*)'******************** END ********************'
      WRITE(*,*)' '
      END

      SUBROUTINE OLD_HEPEUP_PRINT
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)
      SAVE /HEPEUP/
      
      WRITE(*,*)'  IDPRUP = ',IDPRUP
      WRITE(*,*)'  XWGTUP = ',XWGTUP
      WRITE(*,*)'  SCALUP = ',SCALUP
      WRITE(*,*)'  AQEDUP = ',AQEDUP
      WRITE(*,*)'  AQCDUP = ',AQCDUP
      WRITE(*,*)'NUMBER OF PARTICLES = ',NUP
      
      DO I=1,NUP
        WRITE(*,*)'IDUP(',I,')  = ',IDUP(I)
        WRITE(*,*)'ISTUP(',I,') = ',ISTUP(I)
        WRITE(*,*)'MOTHUP(1,',I,') = ',MOTHUP(1,I)
        WRITE(*,*)'MOTHUP(2,',I,') = ',MOTHUP(2,I)
        WRITE(*,*)'ICOLUP(1,',I,') = ',ICOLUP(1,I)
        WRITE(*,*)'ICOLUP(2,',I,') = ',ICOLUP(2,I)
        WRITE(*,*)'MOMENTUM:'
        WRITE(*,*)'PUP(1,',I,') = ',PUP(1,I)
        WRITE(*,*)'PUP(2,',I,') = ',PUP(2,I)
        WRITE(*,*)'PUP(3,',I,') = ',PUP(3,I)
        WRITE(*,*)'PUP(4,',I,') = ',PUP(4,I)
        WRITE(*,*)'PUP(5,',I,') = ',PUP(5,I)
        WRITE(*,*)' '
        WRITE(*,*)'VTIMUP(',I,') = ',VTIMUP(I)
        WRITE(*,*)'SPINUP(',I,') = ',SPINUP(I)
      ENDDO
      END
