*************************************************************************
*                          UPEVNT routine                               *
*          for CompHEP 41.10  -  PYTHIA 6.2 interface                   *
*************************************************************************
*  25.11.2001       Ilyin V.A.                                          *
*************************************************************************
      SUBROUTINE UPEVNT
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)
      SAVE /HEPEUP/

      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)

*...CompHEP-PYTHIA interface
      COMMON/SUBPROC/NNUP(100),KFP(100,20),
     .               NEV(100),XM(100,20,3),SIGMA(100),NPROC
      COMMON/BEAMS/SQRTS,RPDTY,KFB(2),BMASS(2),BEAM(2)

      INTEGER IS,NEVPY,FIREVT      
      REAL*8 PP(20,4)
      CHARACTER EVFILE*500,PROCESS*80,LINE*500
      CHARACTER BEAM*16
      character chain*60, K1*1, K2*1, XN*2      
      COMMON/CCHAIN/ICC(100,2,20)
      COMMON/ISMEAR/ISMEAR
      COMMON/INPARM/IS,NEVPY,FIREVT,PROCESS,EVFILE
      COMMON/QCDPAR/QCDLF(6),NNL
      COMMON/RANDM0/IDUM
      LOGICAL FIRST
      DATA FIRST/.TRUE./
      SAVE
       
       IPSGN = 1
*...if BEAM(1)=BEAM(2) the simmetrization Z->-Z is made
      IF (KFB(1).eq.KFB(2)) THEN
       IF (FIRST) THEN
         FIRST = .FALSE.
         IDUM = -1
       ENDIF
       XRND = pyr(0)
       IF (XRND.lt.0.5d0) IPSGN=-1
       IF (XRND.lt.0.d0 .or. XRND.ge.1.d0) THEN
            write (*,*) 'RAN2 out of [0,1)'
            stop
       ENDIF
      ENDIF

*...read current event
      PP(1,1)=0d0
      PP(1,2)=0d0
      PP(2,1)=0d0
      PP(2,2)=0d0
      READ(IS,FMT='(A500)',END=1000,ERR=1000) LINE  
      READ(LINE,FMT='(i6)') NPRC
      Num=3*(NNUP(NPRC)-2)+2
      CALL ITOCHR(XN,NUM)
      READ(LINE,FMT='(i6,'//XN//'G18.10,G12.3,1x,A)',END=1000,
     .ERR=1000)  NPRC,PP(1,3),PP(2,3),((PP(N,J),J=1,3),N=3,NNUP(NPRC)),
     .QUP,chain

*... random phi generation 
      PI      = DACOS(-1d0)
      PHI_RND = 2D0*PI*PYR(0)
      DO N=3,NNUP(NPRC)
        XX=PP(N,1)
	YY=PP(N,2)
	PP(N,1)=XX*COS(PHI_RND)-YY*SIN(PHI_RND)
	PP(N,2)=XX*SIN(PHI_RND)+YY*COS(PHI_RND)
      ENDDO

*...the number of particle entries in the current event
      NUP =  NNUP(NPRC)
*...the identity of the current subprocess
      IDPRUP = LPRUP(NPRC)
*...the event weight
      XWGTUP = 1.d0
*...scale Q of the event (factorization scale)
      SCALUP = QUP
*...the QED coupling used
      AQEDUP = -1    ! not QED process
*...the QCD coupling used for this event (ME)
      AQCDUP = ALPHAS2(SCALUP,QCDLF(5),NNL)  ! the same as factorization scale
*...particle identity code
      DO 100 i=1,NUP
        IDUP(i) = KFP(nprc,i)
100   CONTINUE
*...status code of particle
      ISTUP(1) = -1
      ISTUP(2) = -1
      DO 110 i=3,NUP
        ISTUP(i) = 1
110   CONTINUE
*...position of first and last mother of particle
       MOTHUP(1,1) = 0 
       MOTHUP(2,1) = 0 
       MOTHUP(1,2) = 0 
       MOTHUP(2,2) = 0 
      DO 120 i=3,NUP
       MOTHUP(1,i) = 1 
       MOTHUP(2,i) = 2
120   CONTINUE
*...the particle momenta
      DO 200 NN=1,NUP
        PUP(1,NN)=PP(NN,1)
        PUP(2,NN)=PP(NN,2)
        PUP(3,NN)=PP(NN,3)*IPSGN
        PUP(4,NN)=SQRT(PP(NN,1)**2+PP(NN,2)**2+PP(NN,3)**2
     .                 +XM(nprc,NN,1)**2)
        PUP(5,NN)=XM(nprc,NN,1)
200   CONTINUE
*...invariant lifetime
      DO 300 i=1,NUP
       VTIMUP(i) = 0.d0
300   CONTINUE
*...spin information
      DO 400 i=1,NUP
       SPINUP(i) = 9
400   CONTINUE


*...swap Z axis for momenta if BEAM(1)=BEAM(2)
        IF (IPSGN.eq.-1) THEN
          IDUPx   = IDUP(1)
          IDUP(1) = IDUP(2)
          IDUP(2) = IDUPx
          DO 135 I=1,5
             XPUP     = PUP(I,1)
             PUP(I,1) = PUP(I,2)
135          PUP(I,2) = XPUP
        ENDIF

*...Breit-Wigner smearing of masses for unstable particles in OUT state if yes
       IF (ISMEAR.eq.1) CALL SMEARMASS

*...set color flows
      DO 10 I=1,30
       IF (CHAIN(I:I+1).EQ.') ') LENGTH=I
10    CONTINUE       
      ITAG = 500
      DO 111 I=1,NUP
        ICOLUP(1,i) = 0
        ICOLUP(2,i) = 0
111   CONTINUE
      DO 222 I=1,LENGTH,5
        K1=CHAIN(I+1:I+1)
        N1=NUMBER(K1)
        K2=CHAIN(I+3:I+3)
        N2=NUMBER(K2)
        IF (IPSGN.eq.-1) THEN
          IF (N1.eq.1) THEN
                 N1=2
          ELSEIF (N1.eq.2) THEN
                 N1=1
          ENDIF
          IF (N2.eq.1) THEN
                 N2=2
          ELSEIF (N2.eq.2) THEN
                 N2=1
          ENDIF
        ENDIF
        IF (N1.le.2) THEN
          ICOLUP(1,N1) = ITAG
        ELSE
          ICOLUP(2,N1) = ITAG
        ENDIF
        IF (N2.le.2) THEN
          ICOLUP(2,N2) = ITAG
        ELSE
          ICOLUP(1,N2) = ITAG
        ENDIF
        ITAG = ITAG+1
222   CONTINUE

      RETURN

*...EOF or error in reading events from CompHEP output
1000  NUP = 0

      RETURN
      END


      FUNCTION NUMBER(PARTON)
      CHARACTER PARTON*1
      IF (PARTON.EQ.'1') THEN 
      NUMBER=1
       ELSEIF(PARTON.EQ.'2') THEN        
       NUMBER=2
        ELSEIF(PARTON.EQ.'3') THEN         
	NUMBER=3
         ELSEIF(PARTON.EQ.'4') THEN          
	 NUMBER=4
          ELSEIF(PARTON.EQ.'5') THEN 	  
	  NUMBER=5
	   ELSEIF(PARTON.EQ.'6') THEN
	   NUMBER=6
	    ELSEIF(PARTON.EQ.'7') THEN
	    NUMBER=7
	     ELSEIF(PARTON.EQ.'8') THEN
	     NUMBER=8
	      ELSEIF(PARTON.EQ.'9') THEN
              NUMBER=9  
	      ELSE
	      NUMBER=10
      ENDIF
      END 
	 

*******************************************************
*                    FUNCTION                         *
* Conversion of integer number into character string  *
*******************************************************
*   Input:  ICHR - output string,                     *
*           JJ - integer number under the conversion; *
*   Output: ITOCHR - the character string,            *
*             declare ICHR at least as                *
*                CHARACTER*LENINT(JJ)                 *
*******************************************************
      SUBROUTINE ITOCHR(ICHR,JJ)
      IMPLICIT REAL*8(A-H,O-Z),INTEGER(I-N) 
      CHARACTER ICHR*(*)
      CHARACTER XFMT*10,XCC

      ICHR=' '
      WRITE(XCC,FMT='(I1)') LENINT(JJ)
      XFMT='(I'//XCC//')'
      WRITE(ICHR,FMT=XFMT,err=1) JJ

      goto 9000
1     write(*,*) 'Error in ITOCHR.'
      read(*,*)

9000  RETURN
      END

********************************************
*           FUNCTION                       *
*     Length of the integer number         *
********************************************
      INTEGER FUNCTION LENINT(JJ)
      IMPLICIT REAL*8(A-H,O-Z),INTEGER(I-N)
      KK=1
10    CONTINUE
      IF (JJ .LT. 10**KK) THEN
         LLL=KK
         GOTO 20
      ENDIF
      KK=KK+1 
      GOTO 10

20    LENINT=LLL
      RETURN
      END


